#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    uint16_t uint16_eq_const_0_0;
    uint64_t uint64_eq_const_1_0;
    int16_t int16_eq_const_2_0;
    uint16_t uint16_eq_const_3_0;
    uint32_t uint32_eq_const_4_0;
    uint8_t uint8_eq_const_5_0;
    int8_t int8_eq_const_6_0;
    uint16_t uint16_eq_const_7_0;
    int32_t int32_eq_const_8_0;
    uint32_t uint32_eq_const_9_0;
    int64_t int64_eq_const_10_0;

    if (size < 38)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&uint16_eq_const_0_0, &data[i], 2);
    i += 2;
    memcpy(&uint64_eq_const_1_0, &data[i], 8);
    i += 8;
    memcpy(&int16_eq_const_2_0, &data[i], 2);
    i += 2;
    memcpy(&uint16_eq_const_3_0, &data[i], 2);
    i += 2;
    memcpy(&uint32_eq_const_4_0, &data[i], 4);
    i += 4;
    memcpy(&uint8_eq_const_5_0, &data[i], 1);
    i += 1;
    memcpy(&int8_eq_const_6_0, &data[i], 1);
    i += 1;
    memcpy(&uint16_eq_const_7_0, &data[i], 2);
    i += 2;
    memcpy(&int32_eq_const_8_0, &data[i], 4);
    i += 4;
    memcpy(&uint32_eq_const_9_0, &data[i], 4);
    i += 4;
    memcpy(&int64_eq_const_10_0, &data[i], 8);
    i += 8;


    if (uint16_eq_const_0_0 == 8186)
    if (uint64_eq_const_1_0 == 10577862377900889222u)
    if (int16_eq_const_2_0 == -11835)
    if (uint16_eq_const_3_0 == 44292)
    if (uint32_eq_const_4_0 == 3476281672)
    if (uint8_eq_const_5_0 == 126)
    if (int8_eq_const_6_0 == 67)
    if (uint16_eq_const_7_0 == 52250)
    if (int32_eq_const_8_0 == -19715109)
    if (uint32_eq_const_9_0 == 1192395397)
    if (int64_eq_const_10_0 == -5363137875837177096)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
